# -*- coding: utf-8 -*-

#    Copyright 2018 Youssef El Ouahby <youssef@yaltik.com>
#    Copyright 2018 Fabien Bourgeois <fabien@yaltik.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
""" GOLEM Mail Presend Wizard """

import logging
from odoo import models, fields, api, _
_LOGGER = logging.getLogger(__name__)

class GolemMailPresendWizard(models.TransientModel):
    """ GOLEM Mail Presend Wizard """
    _name = 'golem.mail.presend.wizard'

    recipient_ids = fields.One2many('golem.mail.recipient', 'presend_wizard_id')

    @api.multi
    def edit_email(self):
        """ Call mail_compose_message wizard """
        self.ensure_one()
        wizard = self[0]
        emails = wizard.recipient_ids.filtered(lambda r: not r.partner_id).mapped('email')
        partners = wizard.recipient_ids.filtered(lambda r: not r.opt_out).mapped('partner_id').ids
        return {
            'name' : _('Search results'),
            'type' : 'ir.actions.act_window',
            'res_model' : 'mail.compose.message',
            'context' : {
                'default_composition_mode': 'mass_mail',
                'default_partner_to': "\\",
                'default_use_template': True,
                'default_template_id': self.env.ref('mail.email_template_partner').id,
                'default_no_auto_thread': False,
                'default_from_presend_wizard': True,
                'partners_from_wizard': partners,
                'emails_from_wizard': emails},
            'view_mode': 'form',
            'target': 'new'
            }
